import pygame
from utils import *
from pygame import mixer
from random import*
from math import*
# dessiner un rectangle: pygame.draw.rect(screen,couleur,(x,y,largeur,hauteur))
    # dessiner un cercle: pygame.draw.circle(screen,couleur, [x, y], rayon)

pygame.init()
mixer.init()

# initialisation de l´écran avec sa taille et le titre
screen = pygame.display.set_mode(size)
pygame.display.set_caption("Pong")

# gestion de la vitesse de rafraichissement de l´écran
clock = pygame.time.Clock()

ball_list = []

# création d´une balle
ball = make_ball()
ball_list.append(ball)

#valeurs joueur
playerSpeed=4
playerWidth=20
playerHeight=100

#création d'un rectangle
player1 = pygame.draw.rect(screen,WHITE, [10,H/2-playerHeight/2,20,100])
player2 = pygame.draw.rect(screen,WHITE, [975,H/2-playerHeight/2,20,100])
player1=Rect()
player2=Rect()
player1.y=H/2-playerHeight/2
player2.y=H/2-playerHeight/2

# initialisation des variables à utiliser
canCollide=True  
rebounds=0
cnt=0
run = False
winner = None
ballCanMove=True
ballCanSpawn=True
speed_y=[-5,-4,-3,3,4,5]
p1score=0
p2score=0
timer=0
delay=0
tickspeed=120
x2,y2=0,0

# texte
IsOn=True
textSpaceBarStart = True

retrofont=pygame.font.Font('bit5x3.ttf', 30)
menufont=pygame.font.Font('bit5x5.ttf', 120)
scorefont=pygame.font.Font('bit5x3.ttf', 60)
buttonfont=pygame.font.Font('bit5x5.ttf', 60)

all_fonts = pygame.font.get_fonts()

startText = retrofont.render("Press space bar to start...",1,WHITE)
menuText = menufont.render("PONG",1,WHITE)
onePlayerText = buttonfont.render("1P",1,WHITE)
twoPlayerText = buttonfont.render("2P",1,WHITE)


menurun=True     
ButtonSize=[150,80]
border1=25
border2=25
ydiff1=border1/2-2
ydiff2=border2/2-2
predicty=H/2


#sound settings
volume=1
chan1 = pygame.mixer.Channel(0)
chan1.set_volume(volume,volume)
#sound image init

imagerect=pygame.Surface((100,100))



Prediction=False

def PaddleTo(DestinationY,playerY):
    if playerY+playerHeight/2<DestinationY: #and playerY<H/2:
        playerY+=playerSpeed
    if playerY+playerHeight/2>DestinationY: #and playerY+playerHeight/2>0:
        playerY-=playerSpeed
    return playerY
   
                
def CPULastKey(DestinationY,playerY,KeyPress):
    if playerY+playerHeight/2<DestinationY:
        KeyPress="down"
    elif playerY+playerHeight/2>DestinationY:
        KeyPress="up"
    else:
        KeyPress=None  
    return KeyPress

# --------------------------------------- Boucle du jeu entier -------------------------------------------------
while True:

    # -------- Boucle du menu principal -----------
    while menurun:
        screen.fill(BLACK)
        
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                menurun=False
                break
            
        
            elif event.type == pygame.MOUSEBUTTONUP and mouse1hover:
                menurun=False
                run=True
                playernumber=2
                
            elif event.type == pygame.MOUSEBUTTONUP and mouse2hover:
                menurun=False
                run=True
                playernumber=1
            
        
        screen.blit(menuText,(W/2-175,H/4))
        
        
        #button 1
        pygame.draw.rect(screen,WHITE, [W/2-ButtonSize[0]-50,H/2,ButtonSize[0],ButtonSize[1]])
        pygame.draw.rect(screen,BLACK, [W/2-ButtonSize[0]-50+border1/2,H/2+border1/2-ydiff1,ButtonSize[0]-border1,ButtonSize[1]-border1+ydiff1])
        screen.blit(twoPlayerText,(W/2-ButtonSize[0]-50+border1+10,H/2+border1-ydiff1-5))
        #button 2
        pygame.draw.rect(screen,WHITE, [W/2+50,H/2,ButtonSize[0],ButtonSize[1]])
        pygame.draw.rect(screen,BLACK, [W/2+50+border2/2,H/2+border2/2-ydiff2,ButtonSize[0]-border2,ButtonSize[1]-border2+ydiff2])
        screen.blit(onePlayerText,(W/2+50+border2+10,H/2+border2-ydiff2-5))
        
        
        
        xmouse,ymouse=pygame.mouse.get_pos()
        ydiff1=border1/2-2
        ydiff2=border2/2-2
        
        mouse1hover=False
        mouse2hover=False
        #check hover button 1
        if ymouse>H/2 and ymouse<H/2+ButtonSize[1]:
            if xmouse>W/2-ButtonSize[0]-50 and xmouse<W/2-50:
                ydiff1=0
                mouse1hover=True
         #check hover/click button 2
            elif xmouse>W/2+50 and xmouse<W/2+50+ButtonSize[0]:
                ydiff2=0
                mouse2hover=True
        
        pygame.display.update()
                    
                    
                    
    # -------- Boucle principale du jeu -----------
    while run:
        chan1.set_volume(volume,volume)
        # --- Gestion des évènements
        
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                run = False
                break 
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE: #if Esc is pressed
                    run=False
                    #reset ball
                    ball_list=[]
                    ball=make_ball()
                    ball_list.append(ball)
                    ballCanMove=True
                    #reset score
                    p2score=0
                    p1score=0
                    menurun=True
                    #reset player pos
                    player1.y, player2.y=H/2-playerHeight/2,H/2-playerHeight/2
                    #reset prediction
                    predicty=H/2
                    #reset winner
                    winner = None


                    
                
                    
        # Mouvement de la balle si SPACEBAR
                elif event.key == pygame.K_SPACE:
                    if event.key == pygame.K_SPACE and ballCanMove==True:
                        if winner=="player2":
                            ball.speed_x = randint(-6,-4)
                        else:
                            ball.speed_x = randint(3,5)
                        ball.speed_y=speed_y[randint(0,5)]
                        ballCanMove=False
                        textSpaceBarStart = False
                        #initiate Prediction
                        predicty=PredictionBall(player2.x, ball.x)
                        

        
        # - - - Ball prediction - - -
        
        
        #prediction "function"

        def PredictionBall(ElemDroit, ElemGauche):
            distance_x = ElemDroit - ElemGauche
            pente = ball.speed_y/ball.speed_x
            image = pente * distance_x + ball.y
            nombre_rebonds=image//(H-2*ball.r)
            if nombre_rebonds % 2==0:
                predicty=image%(H-2*ball.r)
            if nombre_rebonds % 2==1:
                predicty=H-image%(H-2*ball.r)
            return predicty
                
        
        keys = pygame.key.get_pressed()    
        #mouvement joueur
        KP1=None
        KP2=None
        
        if player1.y>0:
            if keys[pygame.K_w]:
                player1.y-=playerSpeed
                KP1="up"
        
        if player2.y>0:
            if keys[pygame.K_UP]:
                player2.y-=playerSpeed
                KP2="up"
                
        if player1.y<W//2:
            if keys[pygame.K_s]:
                player1.y+=playerSpeed
                KP1="down"
                
        if player2.y<W//2:        
            if keys[pygame.K_DOWN]:
                player2.y+=playerSpeed
                KP2="down"

        for ball in ball_list:       
            # mouvement 
            ball.x += ball.speed_x
            ball.y += ball.speed_y
        
            # rebond murs #
            if ball.y > H - ball.r or ball.y < ball.r:
                ball.speed_y *= -1
                PlaySound("PongWallSound.wav")
            
            
            # detection de la sortie de la balle #
            #joueur2
            if ball.x > W + ball.r:
                ball_list=[]
                ball=make_ball()
                ball_list.append(ball)
                ballCanMove=True
                winner="player1"
                rebounds=0
                        #update score
                p1score+=1
                startText = scorefont.render(str(p1score),1,WHITE)
                screen.blit(startText,(50,50))
                
             
            #joueur1
            if ball.x < -10:
                ball_list=[]
                ball=make_ball()
                ball_list.append(ball)
                ballCanMove=True
                winner="player2"
                rebounds=0
                        #update score
                p2score+=1
                startText = scorefont.render(str(p2score),1,WHITE)
                screen.blit(startText,(W-50,H-50))
                
               
                
            # rebond balle sur joueur
         
            #joueur 1
            if (ball.y<=player1.y+playerHeight and ball.y>= player1.y) and (ball.x<=player1.x+playerWidth and ball.x>=player1.x):
                if cnt>10:
                    ball.speed_x*= -1
                    cnt=0
                    rebounds+=1
                    PlaySound("PongPlayerSound.wav")
                    canCollide=False
                    if KP1=="up":
                        ball.speed_y-=3
                        if ball.speed_x <10:
                            ball.speed_x+=1     
                    elif KP1=="down":
                        ball.speed_y+=3
                        if ball.speed_x <10:
                            ball.speed_x+=1
                    else:
                        if ball.speed_x <10:
                            ball.speed_x+=1
                if playernumber==1:
                            #initiate prediction function algorithm
                    predicty=PredictionBall(player2.x, ball.x)
                
                        
             #joueur 2
            if (ball.y<=player2.y+playerHeight and ball.y>= player2.y) and (ball.x<=player2.x+playerWidth and ball.x>=player2.x):
                if cnt>10:
                    ball.speed_x*= -1
                    cnt=0
                    rebounds+=1
                    PlaySound("PongPlayerSound.wav")
                    canCollide=False
                    if playernumber==1:
                        if CPULastKey(ball.y,player2.y,KP2)=="up":
                            ball.speed_y-=3
                            if ball.speed_x >-10:
                                ball.speed_x-=1
                        elif CPULastKey(ball.y,player2.y,KP2)=="down":
                            ball.speed_y+=3
                            if ball.speed_x >-10:
                                ball.speed_x-=1
                        elif ball.speed_x >-10:
                            ball.speed_x-=1
                        #send paddle back to middle
                        predicty=H/2
                        
                    else:
                        if KP2=="up":
                            ball.speed_y-=3
                            if ball.speed_x >-15:
                                ball.speed_x-=1
                        elif KP2=="down":
                            ball.speed_y+=3
                            if ball.speed_x >-15:
                                ball.speed_x-=1
                        else:
                            if ball.speed_x <-15:
                                ball.speed_x-=1            
        

        # --- Dessin
        # fond d´écran
        screen.fill(BLACK)
        
        # text
        if timer>tickspeed//2:
            IsOn = not IsOn
            timer=0
             
        if textSpaceBarStart == True and IsOn==True:
            screen.blit(startText,(320,480))
            
        textScoreP1 = scorefont.render(str(p1score),1,WHITE)
        screen.blit(textScoreP1,(75,50))

        textScoreP2 = scorefont.render(str(p2score),1,WHITE)
        screen.blit(textScoreP2,(W-100,50))
        
        
        # Dessin des balles
        for ball in ball_list:
            pygame.draw.circle(screen,ball.color, [ball.x, ball.y], ball.r)
        
        if playernumber==1:
            
            player1 = pygame.draw.rect(screen,WHITE, [20,player1.y,playerWidth,playerHeight])
            player2 = pygame.draw.rect(screen,WHITE, [965,PaddleTo(predicty, player2.y),playerWidth,playerHeight])
            
        else:
            
            player1 = pygame.draw.rect(screen,WHITE, [20,player1.y,playerWidth,playerHeight])
            player2 = pygame.draw.rect(screen,WHITE, [965,player2.y,playerWidth,playerHeight])
                             
        # 60 mises à jour par seconde
        clock.tick(tickspeed)
        
        # mise à jour de l´écran
        pygame.display.update()
        
        
        # ajout a count
        cnt+=1
        
        chan1.set_volume(volume,volume)
        
        if textSpaceBarStart: timer+=1
        
    if run == False and menurun==False:
        break
        # On sort de la boucle et on quitte
pygame.quit()
    